/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥  
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: taub_pwm.c 20 2015-04-20 14:29:19Z honda $
 */
/*
 *		⡼PWMTAUBɥ饤
 */
#include "Os.h"
#include "v850_gcc/rh850_f1l.h"
#include "taub_pwm.h"
#include "target_sysmod.h"

/*
 * Ѥ˥åȤȥͥ
 */
#define PWM_TAUB_UNIT        0
#define PWM_TAUB_MASTER_CH   0
#define PWM_TAUB_SERVO_CH    8
#define PWM_TAUB_ESC_CH     10

/*
 *  Port 0 Configration for TAUB0 channel 8 and 10
 *   P0_11 : TAUB0O8 : 3
 *   P0_12 : TAUB010 : 3 
 */
#define PWM_P0_MASK			((uint16) 0x1800)
#define PWM_PMC0_INIT		((uint16) 0x1800)
#define PWM_PFCAE0_INIT		((uint16) 0x0000)
#define PWM_PFCE0_INIT		((uint16) 0x1800)
#define PWM_PFC0_INIT		((uint16) 0x0000)
#define PWM_PM0_INIT		((uint16) 0x0000)

/*
 * ϥݡȤͭ
 */
static void
init_pwm_port(void)
{
	uint16 wk;

	/*
	 * PORT0(PWM)
	 */
	/* PFCAE0  */
	wk = sil_reh_mem((void *) PFCAE(0));
	wk &= ~PWM_P0_MASK;
	wk |= (PWM_PFCAE0_INIT & PWM_P0_MASK);
	sil_wrh_mem((void *) PFCAE(0), wk);

	/* PFCE0  */
	wk = sil_reh_mem((void *) PFCE(0));
	wk &= ~PWM_P0_MASK;
	wk |= (PWM_PFCE0_INIT & PWM_P0_MASK);
	sil_wrh_mem((void *) PFCE(0), wk);

	/* PFC0  */
	wk = sil_reh_mem((void *) PFC(0));
	wk &= ~PWM_P0_MASK;
	wk |= (PWM_PFC0_INIT & PWM_P0_MASK);
	sil_wrh_mem((void *) PFC(0), wk);

	/* PMC0  */
	wk = sil_reh_mem((void *) PMC(0));
	wk &= ~PWM_P0_MASK;
	wk |= (PWM_PMC0_INIT & PWM_P0_MASK);
	sil_wrh_mem((void *) PMC(0), wk);

	/* PM0  */
	wk = sil_reh_mem((void *) PM(0));
	wk &= ~PWM_P0_MASK;
	wk |= (PWM_PM0_INIT & PWM_P0_MASK);
	sil_wrh_mem((void *) PM(0), wk);
}

/*
 *  TAUBϢ쥸
 */
#define TAUB_BASE(n)	((uint32) (0xffe30000U + (n * 0x1000U)))
#define TAUBTPS(n)		(TAUB_BASE(n) + 0x240U)
#define TAUBCDR(n, ch)	(TAUB_BASE(n) + (ch * 0x04U))
#define TAUBCNT(n, ch)	(TAUB_BASE(n) + 0x80U + (ch * 0x04U))
#define TAUBCMOR(n, ch)	(TAUB_BASE(n) + 0x200U + (ch * 0x04U))
#define TAUBCMUR(n, ch)	(TAUB_BASE(n) + 0xC0U + (ch * 0x04U))
#define TAUBTS(n)		(TAUB_BASE(n) + 0x1C4)
#define TAUBTT(n)		(TAUB_BASE(n) + 0x1C8U)
#define TAUBRDE(n)		(TAUB_BASE(n) + 0x260U)
#define TAUBRDM(n)		(TAUB_BASE(n) + 0x264U)

#define TAUBTOE(n)		(TAUB_BASE(n) + 0x5CU)
#define TAUBTOM(n)		(TAUB_BASE(n) + 0x248U)
#define TAUBTOC(n)		(TAUB_BASE(n) + 0x24CU)
#define TAUBTOL(n)		(TAUB_BASE(n) + 0x040U)

#define US_TO_COUNT(usec)	    ((usec * (TIMER_CLOCK_HZ/1000)) / 1000)
#define M100NS_TO_COUNT(usec)	(((usec * (TIMER_CLOCK_HZ/1000)) / 1000) / 10)

/*
 *  åCK1
 */
#define MCU_TAUB_MASK_CK1				((uint16) 0xff0f)
#define MCU_TAUB_CK1					((uint16) 0x0040) /* 40Mhz / 16 = 2.5Mhz */

/*
 *  ޥåȿHzˡ2.5MHz
 */
#define TIMER_CLOCK_HZ		((uint32) 2500000)

#define MCU_TAUB_CKS_CK1   (0x01 << 14)
#define MCU_TAUB_MAS       (0x01 << 11)
#define MCU_TAUB_MD0       (0x01 << 0)
#define MCU_TAUB_STS       (0x04 << 8)
#define MCU_TAUB_MD_ONECNT (0x04 << 1)

/*
 *  PSMTAUBν
 */
void
taub_init_pwm(uint32 cycle_us, uint32 servo_duty_us, uint32 esc_duty_us)
{
	uint16 wk;

	/* IPERI2 : TAUB0 CPUCLK2 / 1 = 40MHz */

	/* ƥޤ */
	sil_wrh_mem((void *) TAUBTT(PWM_TAUB_UNIT), (1 << PWM_TAUB_MASTER_CH));
	sil_wrh_mem((void *) TAUBTT(PWM_TAUB_UNIT), (1 << PWM_TAUB_SERVO_CH));
	sil_wrh_mem((void *) TAUBTT(PWM_TAUB_UNIT), (1 << PWM_TAUB_ESC_CH));

	/* ץꥹ */
	wk = sil_reh_mem((void *) TAUBTPS(PWM_TAUB_UNIT));
	wk &= MCU_TAUB_MASK_CK1;
	wk |= MCU_TAUB_CK1;
	sil_wrh_mem((void *) TAUBTPS(PWM_TAUB_UNIT), wk);

	/* ޥͥ */
	sil_wrh_mem((void *) TAUBCMOR(PWM_TAUB_UNIT, PWM_TAUB_MASTER_CH),
				(MCU_TAUB_CKS_CK1|MCU_TAUB_MAS|MCU_TAUB_MD0));
	/* 졼֥ͥ :  */
	sil_wrh_mem((void *) TAUBCMOR(PWM_TAUB_UNIT, PWM_TAUB_SERVO_CH),
				(MCU_TAUB_CKS_CK1|MCU_TAUB_STS|MCU_TAUB_MD_ONECNT|MCU_TAUB_MD0));
	/* 졼֥ͥ : ESC */
	sil_wrh_mem((void *) TAUBCMOR(PWM_TAUB_UNIT, PWM_TAUB_ESC_CH),
				(MCU_TAUB_CKS_CK1|MCU_TAUB_STS|MCU_TAUB_MD_ONECNT|MCU_TAUB_MD0));

	/* 桼⡼ɤ */
	sil_wrb_mem((void *) TAUBCMUR(PWM_TAUB_UNIT, PWM_TAUB_MASTER_CH), 0x00);
	sil_wrb_mem((void *) TAUBCMUR(PWM_TAUB_UNIT, PWM_TAUB_SERVO_CH),  0x00);
	sil_wrb_mem((void *) TAUBCMUR(PWM_TAUB_UNIT, PWM_TAUB_ESC_CH),    0x00);

	/* ƽ񤭴ػ */
	sil_wrb_mem((void *) TAUBRDE(PWM_TAUB_UNIT),0x00);

	/* ͥϥ⡼(졼֤Τ) */
	sil_wrh_mem((void *) TAUBTOE(PWM_TAUB_UNIT), (1 << PWM_TAUB_SERVO_CH)|(1 << PWM_TAUB_ESC_CH));
	sil_wrh_mem((void *) TAUBTOM(PWM_TAUB_UNIT), (1 << PWM_TAUB_SERVO_CH)|(1 << PWM_TAUB_ESC_CH));
	sil_wrh_mem((void *) TAUBTOC(PWM_TAUB_UNIT), 0x00);
	sil_wrh_mem((void *) TAUBTOL(PWM_TAUB_UNIT), 0x00);

	/* 󥿤νͤ */
	sil_wrh_mem((void *) TAUBCDR(PWM_TAUB_UNIT, PWM_TAUB_MASTER_CH), US_TO_COUNT(cycle_us));
	sil_wrh_mem((void *) TAUBCDR(PWM_TAUB_UNIT, PWM_TAUB_SERVO_CH),  US_TO_COUNT(servo_duty_us));
	sil_wrh_mem((void *) TAUBCDR(PWM_TAUB_UNIT, PWM_TAUB_ESC_CH),    US_TO_COUNT(esc_duty_us));

	/* PWMư */
	sil_wrh_mem((void *) TAUBTS(PWM_TAUB_UNIT),
				(1 << PWM_TAUB_MASTER_CH)|(1 << PWM_TAUB_SERVO_CH)|(1 << PWM_TAUB_ESC_CH));

	init_pwm_port();
}

/*
 *  ܤΥǥ塼ƥѹ
 */
void
taub_change_servo_duty(uint32 usec)
{
	sil_wrw_mem((void *) TAUBCDR(PWM_TAUB_UNIT, PWM_TAUB_SERVO_CH), US_TO_COUNT(usec));
}

/*
 *  ESCΥǥ塼ƥѹ
 */
void
taub_change_esc_duty(uint32 usec)
{
	sil_wrw_mem((void *) TAUBCDR(PWM_TAUB_UNIT, PWM_TAUB_ESC_CH), US_TO_COUNT(usec));
}

/*
 *  ESCΥǥ塼ƥѹ(100nsec)
 */
void
taub_change_esc_duty_100ns(uint32 nsec)
{
	sil_wrw_mem((void *) TAUBCDR(PWM_TAUB_UNIT, PWM_TAUB_ESC_CH), M100NS_TO_COUNT(nsec));
}
