/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Software
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥  
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: BodyControl.c 113 2015-05-26 04:04:18Z honda $
 */

/*
 *		ܥǥϴϢ
 */

#include "Os.h"
#include "ModelCarControl.h"
#include "t_syslog.h"

/*
 *  ܥǥϤ˴ؤ
 */
void
BodyControlInit(void)
{
	tInitBody();
}

/*
 * פ˴ؤ
 */
void
LampControl(void)
{
	/* إåɥ */
	HEAD_LAMP_SET(g_bodycmd.headlamp);
	/* ե */
	FOG_LAMP_SET(g_bodycmd.foglamp);
	/* ֥졼 */
	BRAKE_LAMP_SET(g_bodycmd.brakelamp);
	/* Хå */
	BACK_LAMP_SET(g_bodycmd.backlamp);
}

/*
 *  󥫡Ǽѥ󥿤ν
 */
#define CNT_BLINK_INIT  (WINKER_INTERVAL_MS/BODY_CYCLE_MS)

/*
 *  󥫡˴ؤ
 */
void
WinkerControl(void)
{
	static uint8	pre_winker = WINKER_OFF;
	static boolean	pre_winker_lr = FALSE;
	static boolean	pre_winker_l = FALSE;
	static boolean	pre_winker_r = FALSE;
	static uint32	cnt_blink = 0U;

	/*  ؼѲäߥ󥰤Ǽ򳫻Ϥ */
	if (g_bodycmd.winker != pre_winker) {
		cnt_blink = 0U;
	}

	if (cnt_blink == 0U) {
		switch (g_bodycmd.winker) {
		case WINKER_OFF: /*  */
			WINKER_L_SET(FALSE);
			WINKER_R_SET(FALSE);
			break;
		case WINKER_L_ON: /* Τ */
			WINKER_L_SET(TRUE);
			break;
		case WINKER_R_ON: /* Τ */
			WINKER_R_SET(TRUE);
			break;
		case WINKER_LR_ON: /*  */
			WINKER_L_SET(TRUE);
			WINKER_R_SET(TRUE);
			break;
		case WINKER_L_BLINK: /* Τ */
			if (pre_winker_l == FALSE) {
				WINKER_L_SET(TRUE);
				pre_winker_l = TRUE;
			}
			else {
				WINKER_L_SET(FALSE);
				pre_winker_l = FALSE;
			}
			break;
		case WINKER_R_BLINK: /* Τ */
			if (pre_winker_r == FALSE) {
				WINKER_R_SET(TRUE);
				pre_winker_r = TRUE;
			}
			else {
				WINKER_R_SET(FALSE);
				pre_winker_r = FALSE;
			}
			break;
		case WINKER_LR_BLINK: /*  */
			if (pre_winker_lr == FALSE) {
				WINKER_L_SET(TRUE);
				WINKER_R_SET(TRUE);
				pre_winker_lr = TRUE;
			}
			else {
				WINKER_L_SET(FALSE);
				WINKER_R_SET(FALSE);
				pre_winker_lr = FALSE;
			}
			break;
		default:
			break;
		}
		cnt_blink = CNT_BLINK_INIT;
	}

	cnt_blink--;

	pre_winker = g_bodycmd.winker;
}

/*
 *  ܥǥϥ
 */
TASK(BodyControlTask)
{
	uint8 can_rx_data[8];
	uint8 can_rx_size;
	static	boolean executed = FALSE;

	/* ưΤ߼¹ */
	if (executed == FALSE) {
		syslog(LOG_NOTICE, "BodyControlTask : Start!");
		executed = TRUE;
	}

	/* ϤECUʤCANå롥*/
	if (!IsControlerOnECU) {
		tCanGetRxData(BODYCMD_CANMSG_RXMBOX_ID, BODYCMD_CANMSG_ID,
					  &can_rx_data[0], &can_rx_size);
		if (can_rx_size != 0) {
			/* åβ */
			UnpackBodyCmdCanMsg(can_rx_data);
		}
	}

	/* פ˴ؤ */
	LampControl();

	/* 󥫡˴ؤ */
	WinkerControl();

	TerminateTask();
}

/*
 *  ֥ѤΥ顼ॳХå
 */
ALARMCALLBACK(BuzzerControlCycAlarmCb){
	static boolean	buzzer_toggle = FALSE;
	static uint16	buzzer_cycle = 0U;
	boolean 		buzzer_on = FALSE;

	switch (g_bodycmd.buzzer) {
	  case BUZZER_OFF:
		/* ò */
		buzzer_cycle = 0U;
		break;
	  case BUZZER_ON:
		/* ȯ */
		buzzer_on = TRUE;
		break;
	  case BUZZER_INTERVAL_ON:
		/* ֳ֤ȯ */
		buzzer_cycle++;
		if (buzzer_cycle < ((BUZZER_INTERVAL_MS * 1000)/BUZZER_CYCLE_NS)) {
			buzzer_on = TRUE;
		}
		if (buzzer_cycle == ((BUZZER_INTERVAL_MS * 1000)/BUZZER_CYCLE_NS)*2) {
			buzzer_cycle = 0U;
		}
		break;
	  default:
		break;
	}

	if (buzzer_on == TRUE) {
		tSetBuzzer(buzzer_toggle);
		buzzer_toggle = (buzzer_toggle == TRUE) ? FALSE : TRUE;
	} else {
		tSetBuzzer(FALSE);
	}
}
