/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: rc_car.h 20 2015-04-20 14:29:19Z honda $
 */

/*
 *		ϴϢ
 */

#include "Os.h"
#include "ModelCarControl.h"
#include "t_syslog.h"
#include "rcb3.h"

/*
 *  Ѥν
 */
void
OperationInit(void)
{
	tInitSBDBTUart();
	rcb3_Init();
}

/*
 *  RCB3ޥɤϤؤλؼѴ
 */
void
OperationControl(void)
{
	uint16 rcb3_bstate;
	sint8		angle;
	sint8		speed;
	sint8		steern;
	sint8		gain;
	boolean		brake    = FALSE;
	boolean		headlamp = FALSE;
	boolean		foglamp  = FALSE;
	boolean		winker_l = FALSE;
	boolean		winker_r = FALSE;
	boolean		hazard   = FALSE;

	/* ܥ֤ */
	rcb3_bstate = (g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_H] << 8U)
	                          | (g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_L]);

	/* ON/OFFڤؤ */
	if ((rcb3_bstate & RCB3_MSG_BUTTON_NOUGHT) != 0U) {
		headlamp = TRUE;
	}
	if ((rcb3_bstate & RCB3_MSG_BUTTON_SQUARE) != 0U) {
		foglamp = TRUE;
	}
	if ((rcb3_bstate & RCB3_MSG_BUTTON_TRIANGLE) != 0U) {
		hazard = TRUE;
	}
	if ((rcb3_bstate & RCB3_MSG_BUTTON_R1) != 0U) {
		winker_r = TRUE;
	}
	if ((rcb3_bstate & RCB3_MSG_BUTTON_L1) != 0U) {
		winker_l = TRUE;
	}

	/* ɳ(-6364Ĵ) */
	angle = (-1) * (g_rcb3_rmsg[RCB3_MSG_OFFSET_L_ANALOG_LR] - 64);

	/* ®(-6364Ĵ) */
	speed = (-1) * (g_rcb3_rmsg[RCB3_MSG_OFFSET_R_ANALOG_UD] - 64);

	/* ƥ󥰥˥塼ȥĴ */
	if ((rcb3_bstate & RCB3_MSG_BUTTON_UP) != 0U) {
		steern = CONTCMD_STEERN_I; /* ƥ󥰥˥塼ȥͤ */
	}
	else if ((rcb3_bstate & RCB3_MSG_BUTTON_RIGHT) != 0U) {
		steern = CONTCMD_STEERN_R; /* ƥ󥰤Υ˥塼ȥ򱦤Ĵ */
	}
	else if ((rcb3_bstate & RCB3_MSG_BUTTON_LEFT) != 0U) {
		steern = CONTCMD_STEERN_L; /* ƥ󥰤Υ˥塼ȥ򺸤Ĵ */
	}
	else {
		steern = 0U; /* ׵ʤ */
	}

	/* ®Ĵ */
	if ((rcb3_bstate & RCB3_MSG_BUTTON_DOWN) != 0U) {
		gain = CONTCMD_GAIN_I;  /* ⡼ͤˤ */
	}
	else if ((rcb3_bstate & RCB3_MSG_BUTTON_R2) != 0U) {
		gain = CONTCMD_GAIN_U;  /* ⡼1ʳ夲 */
	}
	else if ((rcb3_bstate & RCB3_MSG_BUTTON_L2) != 0U) {
		gain = CONTCMD_GAIN_D;  /* ⡼1ʳ */
	}
	else {
		gain = 0U;  /* ׵ʤ */
	}

	/* ֥졼 */
	if ((rcb3_bstate & RCB3_MSG_BUTTON_CROSS) != 0U) {
		brake = TRUE;
	}

	/* g_contcmd ι */
	g_contcmd.angle    = angle;
	g_contcmd.speed    = speed;
	g_contcmd.gain     = gain;
	g_contcmd.steern   = steern;
	g_contcmd.brake    = brake;
	g_contcmd.headlamp = headlamp;
	g_contcmd.foglamp  = foglamp;
	g_contcmd.hazard   = hazard;	
	g_contcmd.winker_l = winker_l;
	g_contcmd.winker_r = winker_r;

	/* ϤعäȤ */
	UpDateContCmd = TRUE;

	/* ϤECUǼ¹ԤƤξCAN */
	if (!IsControlerOnECU) {
		SendContCmdCanMag();
	}
}

/*
 *  ޥ͡㥿
 */
TASK(OperationManagerTask)
{
	unsigned char	c;
	static	boolean executed = FALSE;

	/* ưΤ߼¹ */
	if (executed == FALSE) {
		syslog(LOG_INFO, "OperationManagerTask : Start!");
		executed = TRUE;
	}

	while(tReceiveSBDBTUart(&c, 1)) {
		if (rcb3_AddReceivedByte(c)) {
			/* RCB3ޥɤϥޥɤѴ */
			OperationControl();
		}
	}

	TerminateTask();
}

/*
 *  rcb3_AddReceivedByteΥ顼Хå
 */
void
rcb3_ErrorCb(uint8 sum, uint8 recv_sum, uint8 *p_rcb3_rmsg)
{
	uint32 i;

	syslog(LOG_INFO, "## RCB3 Sum Error: 0x%x != 0x%x", sum, recv_sum);
	for (i = 0; i < RCB3_MSG_LEN; i++) {
		syslog(LOG_INFO, "## rcb3_rmsg[%d]: 0x%x", i, p_rcb3_rmsg[i]);
	}
}

